package com.diegol.profundiza;

//TODO importante. Redisear la aplicacion de forma que se reduzca el numero de funciones del parseador e intentar estandarizar
// el paso click->webview

import java.util.ArrayList;
import java.util.concurrent.ExecutionException;

import android.app.SearchManager;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import com.actionbarsherlock.app.ActionBar;
import com.actionbarsherlock.app.ActionBar.Tab;
import com.actionbarsherlock.app.SherlockFragmentActivity;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuItem;
import com.actionbarsherlock.widget.SearchView;

public class MainActivity extends SherlockFragmentActivity {

	private static String ACTIVE_TAB = "activeTab";
	private View loadedView;
	private ArrayList<ArrayList<String>> datos;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		setTheme(R.style.Theme_Sherlock_Light);
		super.onCreate(savedInstanceState);
		// requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_main);
		final ActionBar actionBar = getSupportActionBar();
		// actionBar.setDisplayHomeAsUpEnabled(true); Aade el botn para ir
		// atrs (no es necesario, ni creo que lo sea... pero lo dejo por si
		// aca)
		actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);
		Tab tab1 = actionBar
				.newTab()
				.setText("Inicio")
				.setTabListener(
						new TabListener<TabFragmentInicio>(this, "tab1",
								TabFragmentInicio.class));
		actionBar.addTab(tab1);

		Tab tab2 = actionBar
				.newTab()
				.setText("Centros")
				.setTabListener(
						new TabListener<TabFragmentCentros>(this, "tab2",
								TabFragmentCentros.class));
		actionBar.addTab(tab2);

		Tab tab3 = actionBar
				.newTab()
				.setText("Categoras")
				.setTabListener(
						new TabListener<TabFragmentCategorias>(this, "tab3",
								TabFragmentCategorias.class));
		actionBar.addTab(tab3);
		ViewGroup parent = (ViewGroup) findViewById(R.id.layout_main);
		loadedView = LayoutInflater.from(getBaseContext()).inflate(
				R.layout.lay_inicio, parent, false);
		parent.addView(loadedView);

		if (savedInstanceState != null) {
			getSupportActionBar().setSelectedNavigationItem(
					savedInstanceState.getInt(ACTIVE_TAB));
		}
	}

	@Override
	protected void onSaveInstanceState(Bundle outState) {
		// save active tab
		outState.putInt(ACTIVE_TAB, getSupportActionBar()
				.getSelectedNavigationIndex());
		super.onSaveInstanceState(outState);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getSupportMenuInflater().inflate(R.menu.menu, menu);
		SearchManager searchManager = (SearchManager) getSystemService(Context.SEARCH_SERVICE);
		SearchView searchView = (SearchView) menu.findItem(R.id.menu_search)
				.getActionView();
		if (null != searchView) {
			searchView.setSearchableInfo(searchManager
					.getSearchableInfo(getComponentName()));
			searchView.setIconifiedByDefault(false);
		}

		SearchView.OnQueryTextListener queryTextListener = new SearchView.OnQueryTextListener() {
			public boolean onQueryTextChange(String newText) {
				// Accion a ejecutar cuando clickas la lupa y/o cuando tecleas
				return true;
			}

			public boolean onQueryTextSubmit(String query) {
				// Accion que se ejecuta cuando mandas la query. Aqui llamar al
				// AsyncTask que hace la consulta en la web

				datos = new ArrayList<ArrayList<String>>();
				try {
					datos = new ParseoAsincrono(getApplicationContext())
							.execute(
									"http://profundiza.org/?s=" + query
											+ "&submit=Buscar").get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getApplicationContext())
								.execute(
										"http://profundiza.es/?s=" + query
												+ "&submit=Buscar").get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				if (datos.isEmpty()) {
					// mostrar mensaje de error
					Toast.makeText(getApplicationContext(),
							"No hubo ninguna coincidencia", Toast.LENGTH_LONG)
							.show();
				} else {
					if (datos != null) {
						Intent intent = new Intent(getApplicationContext(),
								ListViewBusqueda.class);
						Bundle bundle = new Bundle();
						bundle.putStringArrayList("titulos", datos.get(0));
						bundle.putStringArrayList("urls", datos.get(1));
						intent.putExtras(bundle);
						intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
						getApplicationContext().startActivity(intent);
					}
				}
				return true;
			}
		};
		searchView.setOnQueryTextListener(queryTextListener);

		// Aadir aqui que salte el listviewActivity con los titulos+urls etc
		// etc...
		return super.onCreateOptionsMenu(menu);
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem menu) {
		return onSearchRequested();
	}

}
